//Fiber Closure Equations
#if !defined initfirst1
	#define initfirst1
	volScalarField dyadA2D = A2 && D;
	volScalarField dyadUnitTensorD = UnitTensor && D;
	
	volTensorField ClosureQuadrat = dyadA2D  * A2;
	
	volTensorField ClosureLinear = 	 -1.0/35.0*( dyadUnitTensorD * UnitTensor + 2.0*D  ) 
					+ 1.0/7.0*( dyadUnitTensorD * A2 + 2.0*(A2 & D) 
					+ dyadA2D * UnitTensor + 2.0*(D & A2));
					
	fHybrid  = 1.0-27.0*det(A2);				
	//Hybrid Closure
	volTensorField ClosureA4 = fHybrid*ClosureQuadrat + (1.0-fHybrid)*ClosureLinear;

	volTensorField WA2 = -(W & A2);
	volTensorField A2W = ( A2& W); 
	volTensorField DA2 = lambda*(D &  A2);
	volTensorField A2D = lambda*(A2 & D) ;
		
	volScalarField magnitudeD = pow(0.5*(D && D.T()),0.5);
	volTensorField SourceInteract = 2.0*CI*magnitudeD*(UnitTensor - 3.0*A2);
	
if(FiberVolfracWallFunc){
	//Phan-Thien(2002)
	volScalarField CI_Field = 0.03*(1.0-Foam::exp(-0.224* FiberVolfracField*r));

	if ( FiberVolfrac*r > 1.3){
	//Bay
		CI_Field = 0.0184*Foam::exp(-0.7148* FiberVolfracField*r);
	}
	
		SourceInteract = 2.0*CI_Field*magnitudeD*(UnitTensor - 3.0*A2);
}	

	
	SourceA2 = - WA2 - A2W  + DA2 + A2D - 2.0*lambda * ClosureA4 + SourceInteract;
#else
	dyadA2D = A2 && D;
	dyadUnitTensorD = UnitTensor && D;

	ClosureQuadrat = dyadA2D  * A2;

	ClosureLinear =	 -1.0/35.0*( dyadUnitTensorD * UnitTensor + 2.0*D ) 
			+ 1.0/7.0*( dyadUnitTensorD * A2 + 2.0*(A2 & D) 
			+ dyadA2D * UnitTensor + 2.0*(D & A2));
				
	fHybrid  = 1.0-27.0*det(A2);				
	//Hybrid Closure
	ClosureA4 = fHybrid*ClosureQuadrat + (1.0-fHybrid)*ClosureLinear;

	WA2 = -(W & A2);
	A2W = ( A2& W); 
	DA2 = lambda*(D &  A2);
	A2D = lambda*(A2 & D) ;
		
	magnitudeD = pow(0.5*(D && D.T()),0.5);
	SourceInteract = 2.0*CI*magnitudeD*(UnitTensor - 3.0*A2);
	
if(FiberVolfracWallFunc){
	//Phan-Thien(2002)
	volScalarField CI_Field = 0.03*(1.0-Foam::exp(-0.224* FiberVolfracField*r));

	if ( FiberVolfrac*r > 1.3){
	//Bay
		CI_Field = 0.0184*Foam::exp(-0.7148* FiberVolfracField*r);
	}
	
	SourceInteract = 2.0*CI_Field*magnitudeD*(UnitTensor - 3.0*A2);
}	
	SourceA2 = - WA2 - A2W  + DA2 + A2D - 2.0*lambda * ClosureA4 + SourceInteract; //Vorzeichen von W andersrum als Advani definiert!!
#endif



