//Fiber Interaction coefficient
//Bay
scalar CI;
if ( FiberVolfrac*r > 1.3){
	CI = 0.0184*Foam::exp(-0.7148* FiberVolfrac*r);
}
else{
//Phan-Thien(2002)
	CI = 0.03*(1.0-Foam::exp(-0.224* FiberVolfrac*r));
}

//CI = 0.0;

if(FiberVolfracWallFunc){
//	Volume fraction linear decrease in "wallzone"
		
	scalar FiberVolfracMean = FiberVolfrac;
	scalar FiberVolfracBulk = FiberVolfracMean*lengthfactor.value()/(lengthfactor.value()-wallzone.value()/2.0);
			
	wallDist y(mesh,true);	
	
	
	//SET INLET PATCH
	Info<< "Reading ChannelSettings\n" << endl;
	IOdictionary ChannelSettings
	(
		IOobject
		(
			"ChannelSettings",
			runTime.constant(),
			mesh,
			IOobject::MUST_READ,
			IOobject::NO_WRITE
		)
	);
	
	bool PeriodicY;
	bool PeriodicZ;
	if (ChannelSettings.found("PeriodicDirection"))
	{
		word PeriodicDirection(ChannelSettings.lookup("PeriodicDirection"));

		if (PeriodicDirection == "Y"){
			PeriodicY = true;
			PeriodicZ = false;
		}
		if(PeriodicDirection == "Z"){
			PeriodicZ = true;
			PeriodicY = false;
		}
	}
   
	scalar SizeY(
			readScalar(ChannelSettings.lookup("SizeY"))
		    ); 
	scalar SizeZ(
			readScalar(ChannelSettings.lookup("SizeZ"))
		    ); 

	// Get index of patch
	label inletPatchID = mesh.boundaryMesh().findPatchID("inlet");
	
	// Get reference to boundary value
	const fvPatchVectorField& faceCentreshub 		=mesh.Cf().boundaryField()[inletPatchID];
	fvPatchScalarField& InletVolfrac = FiberVolfracField.boundaryField()[inletPatchID];
	
	double Hy = SizeY/2.0; //Channel-Half-Height (y-direction)
	double Hz = SizeZ/2.0; //Channel-Half-Height (z-direction)	
	
	// loop over all hub faces
	forAll(InletVolfrac, faceI)
	{
		// get coordinate for face centre
		const vector& c = faceCentreshub[faceI];
		
		if(PeriodicZ==true){
	
			double 	cy = c.component(vector::Y);
			InletVolfrac[faceI] = FiberVolfracBulk*cy/wallzone.value();
			if( cy > wallzone.value()){
				if(cy > SizeY-wallzone.value()){
					InletVolfrac[faceI] = FiberVolfracBulk*(SizeY-cy)/wallzone.value();
				}
				else{
					InletVolfrac[faceI] = FiberVolfracBulk;
				}
			}
		}
		if(PeriodicY == true){
			double 	cz = c.component(vector::Z);
			InletVolfrac[faceI] = FiberVolfracBulk*cz/wallzone.value();
			if( cz > wallzone.value()){
				if(cz > SizeZ-wallzone.value()){
					InletVolfrac[faceI] = FiberVolfracBulk*(SizeZ-cz)/wallzone.value();
				}
				else{
					InletVolfrac[faceI] = FiberVolfracBulk;
				}
			}
		}
		
	/*	dimensionedScalar yw = y[faceI];
		if( yw > wallzone){
			InletVolfrac[faceI] = FiberVolfracBulk;
	//		FiberVolfracField[celli] = FiberVolfracMean;
		}
		else{
	//		FiberVolfracField[celli] = FiberVolfracMean*yw.value()/wallzone.value();
			InletVolfrac[faceI] = FiberVolfracBulk*yw.value()/wallzone.value();
		}
	*/
	}
		
	//INNER NODES
	forAll (FiberVolfracField, celli)
	{
		dimensionedScalar yw = y[celli];
		if( yw > wallzone){
			FiberVolfracField[celli] = FiberVolfracBulk;
	//		FiberVolfracField[celli] = FiberVolfracMean;
		}
		else{
	//		FiberVolfracField[celli] = FiberVolfracMean*yw.value()/wallzone.value();
			FiberVolfracField[celli] = FiberVolfracBulk*yw.value()/wallzone.value();
		}
	}
	
	y.write();
	
	FiberVolfracField.write();
	
/*	//Interaction Parameter
	//Phan-Thien(2002)
	volScalarField CI_Field = 0.03*(1.0-Foam::exp(-0.224* FiberVolfracField*r));

	if ( FiberVolfrac*r > 1.3){
	//Bay
		CI_Field = 0.0184*Foam::exp(-0.7148* FiberVolfracField*r);
	}
	
*/


}


