//Calculate Solvent Stress Tensor
#if !defined initStressPTT
#define initStressPTT
/*	const dictionary& PTTCoeffs
	(
		MatrixProperties.subDict("PTTCoeffs")
	);

	scalar nmodes(
		readScalar(PTTCoeffs.lookup("nmodes"))
	);

	List<scalar> epsilon
	(
		PTTCoeffs.lookup("epsilon")
	);
	List<scalar> zeta
	(
		PTTCoeffs.lookup("zeta")
	);

	scalar zeta1 = zeta[0];
	scalar zeta2 = zeta[1];
	scalar zeta3 = zeta[2];
	scalar zeta4 = zeta[3];

	scalar epsilon1 = epsilon[0];
	scalar epsilon2 = epsilon[1];
	scalar epsilon3 = epsilon[2];
	scalar epsilon4 = epsilon[3];

	dimensionedScalar lambda1    ( PTTCoeffs.lookup("lambda1") );
	dimensionedScalar lambda2    ( PTTCoeffs.lookup("lambda2") );
	dimensionedScalar lambda3    ( PTTCoeffs.lookup("lambda3") );
	dimensionedScalar lambda4    ( PTTCoeffs.lookup("lambda4") );

	dimensionedScalar G1    ( PTTCoeffs.lookup("G1") );
	dimensionedScalar G2    ( PTTCoeffs.lookup("G2") );
	dimensionedScalar G3    ( PTTCoeffs.lookup("G3") );
	dimensionedScalar G4    ( PTTCoeffs.lookup("G4") );

	Switch PTTLin(
		 PTTCoeffs.lookup("PTTLin")
	);	
	Switch PTTExp(
		 PTTCoeffs.lookup("PTTExp")
	);	

*/
//4 Mode Multimodular Form

//Mode 1
	volTensorField LD = L - zeta1*D;
	volScalarField gLinear 	= 1.0 + epsilon1*lambda1/nu1*tr(StressSolvent1);	

	volScalarField gExp =Foam::exp(epsilon1*lambda1/nu1*tr(StressSolvent1));	

	fvTensorMatrix StressPTTEqn
		(
			lambda1*(fvm::ddt(StressSolvent1) + fvm::div(phi, StressSolvent1) ) + fvm::SuSp(gLinear,StressSolvent1)
		);
	
	if(PTTExp){
	fvTensorMatrix StressPTTEqn
		(
			lambda1*(fvm::ddt(StressSolvent1) + fvm::div(phi, StressSolvent1) ) + fvm::SuSp(gExp,StressSolvent1)
		);
	}

	
	solve(StressPTTEqn == 2.0*nu1*D + lambda1*(LD & StressSolvent1) + lambda1*(StressSolvent1 & LD.T())) ; 

//Mode 2
	LD = L - zeta2*D;
	gLinear 	= 1.0 + epsilon2*lambda2/nu2*tr(StressSolvent2);	
	gExp =Foam::exp(epsilon2*lambda2/nu2*tr(StressSolvent2));	
	fvTensorMatrix StressPTTEqn2
		(
			lambda2*(fvm::ddt(StressSolvent2) + fvm::div(phi, StressSolvent2) ) + fvm::SuSp(gLinear,StressSolvent2)
		);
	if(PTTExp){
	fvTensorMatrix StressPTTEqn2
		(
			lambda2*(fvm::ddt(StressSolvent2) + fvm::div(phi, StressSolvent2) ) + fvm::SuSp(gExp,StressSolvent2)
		);
	}
	solve(StressPTTEqn2 == 2.0*nu2*D + lambda2*(LD & StressSolvent2) + lambda2*(StressSolvent2 & LD.T())) ; 
        
//Mode 3
	LD = L - zeta3*D;
	gLinear 	= 1.0 + epsilon3*lambda3/nu3*tr(StressSolvent3);	
	gExp =Foam::exp(epsilon3*lambda3/nu3*tr(StressSolvent3));	
	fvTensorMatrix StressPTTEqn3
		(
			lambda3*(fvm::ddt(StressSolvent3) + fvm::div(phi, StressSolvent3) ) + fvm::SuSp(gLinear,StressSolvent3)
		);
	if(PTTExp){
	fvTensorMatrix StressPTTEqn3
		(
			lambda3*(fvm::ddt(StressSolvent3) + fvm::div(phi, StressSolvent3) ) + fvm::SuSp(gExp,StressSolvent3)
		);
	}
	solve(StressPTTEqn3 == 2.0*nu3*D + lambda3*(LD & StressSolvent3) + lambda3*(StressSolvent3 & LD.T())) ; 

//Mode 4
	LD = L - zeta4*D;
	gLinear 	= 1.0 + epsilon4*lambda4/nu4*tr(StressSolvent4);	
	gExp =Foam::exp(epsilon4*lambda4/nu4*tr(StressSolvent4));	
	fvTensorMatrix StressPTTEqn4
		(
			lambda4*(fvm::ddt(StressSolvent4) + fvm::div(phi, StressSolvent4) ) + fvm::SuSp(gLinear,StressSolvent4)
		);
	if(PTTExp){
	fvTensorMatrix StressPTTEqn4
		(
			lambda4*(fvm::ddt(StressSolvent4) + fvm::div(phi, StressSolvent4) ) + fvm::SuSp(gExp,StressSolvent4)
		);
	}
	solve(StressPTTEqn4 == 2.0*nu4*D + lambda4*(LD & StressSolvent4) + lambda4*(StressSolvent4 & LD.T())) ; 

  
//superposition of the four stress tensors
	StressSolvent = StressSolvent1 + StressSolvent2 + StressSolvent3
+ StressSolvent4;
#else
//Mode 1
	LD = L - zeta1*D;

	if(PTTLin){
	gLinear = 1.0 + epsilon1*lambda1/nu1*tr(StressSolvent1);	
	}
	if(PTTExp){
		gExp =Foam::exp( epsilon1*lambda1/nu1*tr(StressSolvent1));	
	}

	fvTensorMatrix StressPTTEqn
		(
			lambda1*(fvm::ddt(StressSolvent1) + fvm::div(phi, StressSolvent1) ) + fvm::SuSp(gLinear,StressSolvent1)
		);
	
	if(PTTExp){
	fvTensorMatrix StressPTTEqn
		(
			lambda1*(fvm::ddt(StressSolvent1) + fvm::div(phi, StressSolvent1) ) + fvm::SuSp(gExp,StressSolvent1)
		);
	}

	solve(StressPTTEqn == 2.0*nu1*D + lambda1*(LD & StressSolvent1) + lambda1*(StressSolvent1 & LD.T())) ; 

//Mode 2
	LD = L - zeta2*D;
	gLinear 	= 1.0 + epsilon2*lambda2/nu2*tr(StressSolvent2);	
	gExp =Foam::exp(epsilon2*lambda2/nu2*tr(StressSolvent2));	
	fvTensorMatrix StressPTTEqn2
		(
			lambda2*(fvm::ddt(StressSolvent2) + fvm::div(phi, StressSolvent2) ) + fvm::SuSp(gLinear,StressSolvent2)
		);
	if(PTTExp){
	fvTensorMatrix StressPTTEqn2
		(
			lambda2*(fvm::ddt(StressSolvent2) + fvm::div(phi, StressSolvent2) ) + fvm::SuSp(gExp,StressSolvent2)
		);
	}
	solve(StressPTTEqn2 == 2.0*nu2*D + lambda2*(LD & StressSolvent2) + lambda2*(StressSolvent2 & LD.T())) ; 

//Mode 3
	LD = L - zeta3*D;
	gLinear 	= 1.0 + epsilon3*lambda3/nu3*tr(StressSolvent3);	
	gExp =Foam::exp(epsilon3*lambda3/nu3*tr(StressSolvent3));	
	fvTensorMatrix StressPTTEqn3
		(
			lambda3*(fvm::ddt(StressSolvent3) + fvm::div(phi, StressSolvent3) ) + fvm::SuSp(gLinear,StressSolvent3)
		);
	if(PTTExp){
	fvTensorMatrix StressPTTEqn3
		(
			lambda3*(fvm::ddt(StressSolvent3) + fvm::div(phi, StressSolvent3) ) + fvm::SuSp(gExp,StressSolvent3)
		);
	}
	solve(StressPTTEqn3 == 2.0*nu3*D + lambda3*(LD & StressSolvent3) + lambda3*(StressSolvent3 & LD.T())) ; 

//Mode 4
	LD = L - zeta4*D;
	gLinear 	= 1.0 + epsilon4*lambda4/nu4*tr(StressSolvent4);	
	gExp =Foam::exp(epsilon4*lambda4/nu4*tr(StressSolvent4));	
	fvTensorMatrix StressPTTEqn4
		(
			lambda4*(fvm::ddt(StressSolvent4) + fvm::div(phi, StressSolvent4) ) + fvm::SuSp(gLinear,StressSolvent4)
		);
	if(PTTExp){
	fvTensorMatrix StressPTTEqn4
		(
			lambda4*(fvm::ddt(StressSolvent4) + fvm::div(phi, StressSolvent4) ) + fvm::SuSp(gExp,StressSolvent4)
		);
	}
	solve(StressPTTEqn4 == 2.0*nu4*D + lambda4*(LD & StressSolvent4) + lambda4*(StressSolvent4 & LD.T())) ; 
  

	StressSolvent = StressSolvent1 + StressSolvent2 + StressSolvent3
+ StressSolvent4;

#endif //end initialization if case

/*	fvTensorMatrix StressPTTEqn
		(
			lambda1*(fvm::ddt(StressSolvent) + fvm::div(phi, StressSolvent) ) + fvm::SuSp(gLinear,StressSolvent)
		);
	
	if(PTTExp){
	fvTensorMatrix StressPTTEqn
		(
			lambda1*(fvm::ddt(StressSolvent) + fvm::div(phi, StressSolvent) ) + fvm::SuSp(gExp,StressSolvent)
		);
	}

	solve(StressPTTEqn == 2.0*nuS*D + lambda1*(LD & StressSolvent_old) + lambda1*(StressSolvent_old & LD.T())) ; 
*/

