#ifndef createFieldsFiber_H
#define createFieldsFiber_H

	volTensorField StressFiber
	(
		IOobject
		(
		"StressFiber",
		runTime.timeName(),
		mesh,
		IOobject::MUST_READ,
		IOobject::NO_WRITE
		),
		mesh
	);

    Info<< "Reading FiberProperties\n" << endl;
    IOdictionary FiberProperties
    (
        IOobject
        (
            "FiberProperties",
            runTime.constant(),
            mesh,
            IOobject::MUST_READ,
            IOobject::NO_WRITE
        )
    );

	scalar mu1(
		readScalar(FiberProperties.lookup("mu1"))
	); 
	 
	scalar mu2(
		readScalar(FiberProperties.lookup("mu2"))
	); 

	scalar r(
		readScalar(FiberProperties.lookup("r"))
	); 

	scalar FiberVolfrac(
		readScalar(FiberProperties.lookup("FiberVolfrac"))
	); 
	
/*	List<scalar> dummy(
		FiberProperties.lookup("dummy")
	);
*/


/*	Switch NonNewtonFiber(
		 FiberProperties.lookup("NonNewtonFiber")
	);	

    if (controlNonNewtonModels.found("FiberClosure"))
	{
	word FiberClosure(controlNonNewtonModels.lookup("FiberClosure"));
		if (FiberClosure == "hybrid"){
			ClosureHybrid = true;
		}
	}
*/

	word FiberClosure(FiberProperties.lookup("FiberClosure"));	
	if (FiberClosure=="hybrid"){
		Info<< "Fiber Closure Model: hybrid " << endl;
	}
	if (FiberClosure=="IBOF"){
		Info<< "Fiber Closure Model: IBOF " << endl;
	}
	

	volTensorField A2 
    	(
        IOobject
        (
            "A2",
            runTime.timeName(),
            mesh,
	    IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
		mesh
    	);

	volTensorField eigenVectorsA2 
	(
        IOobject
        (
            "eigenVectorsA2",
            runTime.timeName(),
            mesh,
	    IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
		eigenVectors(A2)
    	);

	volVectorField eigenValuesA2 
	(
        IOobject
        (
            "eigenValuesA2",
            runTime.timeName(),
            mesh,
	    IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
		eigenValues(A2)
    	);

	volScalarField lambdamax
	( //largest Eigenvalue as scalar Orientation Parameter
        IOobject
        (
            "lambdamax",
            runTime.timeName(),
            mesh,
	    IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
		eigenValuesA2.component(vector::Z)
    	);

	volScalarField fHybrid
	( 
        IOobject
        (
            "fHybrid",
            runTime.timeName(),
            mesh,
	    IOobject::NO_READ,
	    IOobject::AUTO_WRITE
	),
		1.0-27.0*det(A2)
    	);
	
	

	volTensorField SourceA2 
	(
        IOobject
        (
            "SourceA2",
            runTime.timeName(),
            mesh,
	    IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
	mesh
    );


	volScalarField ClosureA4_imp 
	(
		IOobject
		(
		"ClosureA4_imp",
		runTime.timeName(),
		mesh,
		IOobject::MUST_READ,
		IOobject::NO_WRITE
		),
		mesh
	);

	//------------------------------------------------------
	//for inhomogenius fiber Volume Fraction in space//wall function
	Switch FiberVolfracWallFunc(
			FiberProperties.lookup("FiberVolfracWallFunc")
	);
	
	dimensionedScalar wallzone
	(
		FiberProperties.lookup("wallzone")
	);
	dimensionedScalar lengthfactor
	(
		FiberProperties.lookup("lengthfactor")
	);
	
	volScalarField FiberVolfracField
	(
		IOobject
		(
			"FiberVolfracField",
			runTime.timeName(),
			mesh,
			IOobject::MUST_READ,
			IOobject::NO_WRITE
		),
		mesh
	);
	//------------------------------------------------------

	
#endif

/*	volScalarField traceA2 
	(
        IOobject
        (
            "traceA2",
            runTime.timeName(),
            mesh,
	    IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
	tr(A2)
    );
*/


	/*volScalarField 	dimStress 
    	(
        IOobject
        (
            "dimStress",
            runTime.timeName(),
            mesh,
	    IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
        	mesh,
		dimensionedScalar("one",1.0/p.dimensions(),1.0)
    	);
*/
